################################## Dynamic DNS round robin ##################################
:global toJson do={
  :global toJson;
  :local ret "{";
  :local firstIteration true;
  :foreach k,v in $objectParam do={
    if ($firstIteration) do={
      :set $ret ($ret . "\"".$k . "\":")
    } else={
      :set $ret ($ret . "," . "\"". $k . "\":")
    };
    :set $firstIteration false
    :local type [:typeof $v]
    :if ($type = "array") do={
      :set $ret ($ret . [$toJson objectParam=$v])
    } else={
      :if ($type = "str") do={
        :set $ret ($ret . "\"" . $v . "\"")
      } else {
        :set $ret ($ret . $v )
      };
    };
  };
  :set $ret ($ret . "}")
  :return $ret;
};

:local httpRequest do={
	:global toJson;
	:local data {
		"nodeName"="$nodeName";
		"recordType"="A";
		"ttl"=$ttl;
		"state"=$state;
		"group"="$group";
		"ipv4Address"=$wanIP
	};
	:local json [$toJson objectParam=$data];
	#:put $json;
	#:put "url=$url headers=$headers nodeName=$nodeName group=$group state=$state wanIP=$wanIP ttl=$ttl";
	
	/tool fetch url=$url http-method=post http-header-field=$headers http-data=$json output=none
		#:log info "$domain updated IP: $wanIP";
}

:local strReplace do={
	:local str "";
	:for i from=0 to=[:len $string] do={		
		:local char [:pick $string $i ($i+1)];
		if ($char = $curr) do={
			:set str ($str.$new);
		} else={		
			:set str ($str.$char);
		}
	}
	:return $str;
}

:local fileExists do={
	do {
		/file get $file
		:return true;
	} on-error={
		return false;
	}
}

:local createFile do={
	do {
		/file print file=$file
		:return true;
	} on-error={
		return false;
	}
}

:local writeFile do={
	do {
		/file set $file contents=$contents
		:return true;
	} on-error={
		return false;
	}
}

:local readFile do={
	do {
		:local data [/file get $file contents];
		:return $data;
	} on-error={
		return false;
	}
}

:global dnsList2;
:local wan [:toarray ""];
:local api "https://api.dynu.com/v2/dns/";
:local headers "API-Key:6656d6f5a36d663dWVgVVg65437XTWV3,Accept:application/json";
:local ttl 120;
:local getDefaultWan;

:local interfaceRouteTable [/ip route get value-name=gateway-status [find active dst-address=0.0.0.0/0 !routing-mark]];
:local interfaceNames {
	"PPOE_3BB";
	"PPOE_AIS";
}

:local i 0;
:foreach inf in=$interfaceNames do={
	:local internetState ([/interface detect-internet state get [find name=$inf]]->"state");
	if ($interfaceRouteTable~$inf) do={
		#:put "Set var interface -> $inf"
		:set getDefaultWan [:pick [/ip address get value-name=address [find interface=$inf]] 0 ([:len [/ip address get value-name=address [find interface=$inf]]] - 3)];
	}
	
	if ($internetState = "internet") do={
		:local getWanIP [:pick [/ip address get value-name=address [find interface=$inf]] 0 ([:len [/ip address get value-name=address [find interface=$inf]]] - 3)];
		:set ($wan->$i) {
			"ip"=$getWanIP;
			"state"=true;
		};
	} else={
		:set ($wan->$i) {
			"ip"="127.0.0.1";
			"state"=false;
		};
	}

	:set i ($i+1);
}

:local domains {
	{
		"nodeName"="";
		"records_id"={
			"7203438";
			"7203440";
		};
		"zone_id"="9379944";
		"group"="";
		"state"=true;
	};
}

#if ([$fileExists file=$conf] != true) do={
#	$createFile file=$conf
#	:delay 3;
#}

:local dnsConf [:toarray ""]
:foreach d in=$domains do={
	:local nodeName ($d->"nodeName");
	:local recordsId ($d->"records_id");
	:local zoneId ($d->"zone_id");
	:local group ($d->"group");
	:local state ($d->"state");
	:if ([typeof $recordsId] = "array") do={
		:local i 0;
		:foreach id in=$recordsId do={
			:local wanIP ($wan->$i->"ip");
			:local wanState ($wan->$i->"state");
			:local dnsRec ($dnsList2->$id);
			#:put ("$wanIP:".($dnsRec->"ip"));
			if ($wanIP != "127.0.0.1") do={
				:set ($dnsConf->$id) {
					"ip"=$wanIP;
					"recordsId"=$id
				};
				:if ($wanIP != ($dnsRec->"ip")) do={
					$httpRequest url=($api.$zoneId."/record/".$id) headers=$headers group=$group nodeName=$nodeName wanIP=$wanIP ttl=$ttl state=$wanState
					:log info "WAN$i $domain updated IP: $wanIP";
				}
			} else={					
				:set ($dnsConf->$id) {
					"ip"=$wanIP;
					"recordsId"=$id
				};
				:if ($wanIP != ($dnsRec->"ip")) do={
					$httpRequest url=($api.$zoneId."/record/".$id) headers=$headers group=$group nodeName=$nodeName wanIP=$wanIP ttl=$ttl state=$wanState
					:log info "Link down WAN$i $id updated IP: $wanIP";
				}
			}
			:set i ($i+1);
		}
	} else={
		:local dnsRec ($dnsList2->$recordsId);				
		if ([len $getDefaultWan] != 0) do={
			:set ($dnsConf->$recordsId) {
				"ip"=$getDefaultWan;
				"recordsId"=$recordsId
			};
			:if ($getDefaultWan != ($dnsRec->"ip")) do={
				$httpRequest url=($api.$zoneId."/record/".$recordsId) headers=$headers group=$group nodeName=$nodeName wanIP=$getDefaultWan ttl=$ttl state=$state
			:log info "$recordsId updated IP: $getDefaultWan";
			}
		}
	}
}
	
	
	#if ([$fileExists file=$conf] = true) do={
	#	$writeFile file=$conf contents=[$toJson objectParam=$dnsConf]
	#}
	
if ([:len $dnsConf] > 0) do={
	:global dnsList2 $dnsConf;
}
################################## Dynamic DNS round robin ##################################